from fastapi import FastAPI, Header, Request

app = FastAPI()

@app.get("/")
def root(request: Request):
    return {
        "method": request.method,
        "url": {
            "url": request.url._url,
            "scheme": request.url.scheme,
            "hostname": request.url.hostname,
            "port": request.url.port,
            "path": request.url.path,
        },
        "headers": request.headers,
        "client": {
            "ip-address": request.client.host,
            "port": request.client.port,
        },
    }
